diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/network/site-info.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/network/site-info.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/network/site-info.php	2012-10-29 12:35:31.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/network/site-info.php	2012-12-17 16:18:42.000000000 -0600
***************
*** 135,144 ****
  			<th scope="row"><?php _e( 'Path' ) ?></th>
  			<?php if ( $is_main_site ) { ?>
  			<td><code><?php echo esc_attr( $details->path ) ?></code></td>
! 			<?php } else { ?>
  			<td><input name="blog[path]" type="text" id="path" value="<?php echo esc_attr( $details->path ) ?>" size="40" style='margin-bottom:5px;' />
! 			<br /><input type="checkbox" style="width:20px;" name="update_home_url" value="update" <?php if ( get_blog_option( $id, 'siteurl' ) == untrailingslashit( get_blogaddress_by_id ($id ) ) || get_blog_option( $id, 'home' ) == untrailingslashit( get_blogaddress_by_id( $id ) ) ) echo 'checked="checked"'; ?> /> <?php _e( 'Update <code>siteurl</code> and <code>home</code> as well.' ); ?></td>
! 			<?php } ?>
  		</tr>
  		<tr class="form-field">
  			<th scope="row"><?php _ex( 'Registered', 'site' ) ?></th>
--- 135,149 ----
  			<th scope="row"><?php _e( 'Path' ) ?></th>
  			<?php if ( $is_main_site ) { ?>
  			<td><code><?php echo esc_attr( $details->path ) ?></code></td>
! 			<?php
! 			} else {
! 				switch_to_blog( $id );
! 			?>
  			<td><input name="blog[path]" type="text" id="path" value="<?php echo esc_attr( $details->path ) ?>" size="40" style='margin-bottom:5px;' />
! 			<br /><input type="checkbox" style="width:20px;" name="update_home_url" value="update" <?php if ( get_option( 'siteurl' ) == untrailingslashit( get_blogaddress_by_id ($id ) ) || get_option( 'home' ) == untrailingslashit( get_blogaddress_by_id( $id ) ) ) echo 'checked="checked"'; ?> /> <?php _e( 'Update <code>siteurl</code> and <code>home</code> as well.' ); ?></td>
! 			<?php
! 				restore_current_blog();
! 			} ?>
  		</tr>
  		<tr class="form-field">
  			<th scope="row"><?php _ex( 'Registered', 'site' ) ?></th>
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/network/site-new.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/network/site-new.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/network/site-new.php	2012-10-29 12:35:31.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/network/site-new.php	2012-12-17 16:18:42.000000000 -0600
***************
*** 62,71 ****
  
  	if ( is_subdomain_install() ) {
  		$newdomain = $domain . '.' . preg_replace( '|^www\.|', '', $current_site->domain );
! 		$path = $base;
  	} else {
  		$newdomain = $current_site->domain;
! 		$path = $base . $domain . '/';
  	}
  
  	$password = 'N/A';
--- 62,71 ----
  
  	if ( is_subdomain_install() ) {
  		$newdomain = $domain . '.' . preg_replace( '|^www\.|', '', $current_site->domain );
! 		$path      = $current_site->path;
  	} else {
  		$newdomain = $current_site->domain;
! 		$path      = $current_site->path . $domain . '/';
  	}
  
  	$password = 'N/A';
***************
*** 85,91 ****
  	if ( !is_wp_error( $id ) ) {
  		if ( !is_super_admin( $user_id ) && !get_user_option( 'primary_blog', $user_id ) )
  			update_user_option( $user_id, 'primary_blog', $id, true );
! 		$content_mail = sprintf( __( "New site created by %1s\n\nAddress: %2s\nName: %3s"), $current_user->user_login , get_site_url( $id ), stripslashes( $title ) );
  		wp_mail( get_site_option('admin_email'), sprintf( __( '[%s] New Site Created' ), $current_site->site_name ), $content_mail, 'From: "Site Admin" <' . get_site_option( 'admin_email' ) . '>' );
  		wpmu_welcome_notification( $id, $user_id, $password, $title, array( 'public' => 1 ) );
  		wp_redirect( add_query_arg( array( 'update' => 'added', 'id' => $id ), 'site-new.php' ) );
--- 85,94 ----
  	if ( !is_wp_error( $id ) ) {
  		if ( !is_super_admin( $user_id ) && !get_user_option( 'primary_blog', $user_id ) )
  			update_user_option( $user_id, 'primary_blog', $id, true );
! 		$content_mail = sprintf( __( 'New site created by %1$s
! 
! Address: %2$s
! Name: %3$s' ), $current_user->user_login , get_site_url( $id ), stripslashes( $title ) );
  		wp_mail( get_site_option('admin_email'), sprintf( __( '[%s] New Site Created' ), $current_site->site_name ), $content_mail, 'From: "Site Admin" <' . get_site_option( 'admin_email' ) . '>' );
  		wpmu_welcome_notification( $id, $user_id, $password, $title, array( 'public' => 1 ) );
  		wp_redirect( add_query_arg( array( 'update' => 'added', 'id' => $id ), 'site-new.php' ) );
***************
*** 127,133 ****
  			<?php } else {
  				echo $current_site->domain . $current_site->path ?><input name="blog[domain]" class="regular-text" type="text" title="<?php esc_attr_e( 'Domain' ) ?>"/>
  			<?php }
! 			echo '<p>' . __( 'Only the characters a-z and 0-9 recommended.' ) . '</p>';
  			?>
  			</td>
  		</tr>
--- 130,136 ----
  			<?php } else {
  				echo $current_site->domain . $current_site->path ?><input name="blog[domain]" class="regular-text" type="text" title="<?php esc_attr_e( 'Domain' ) ?>"/>
  			<?php }
! 			echo '<p>' . __( 'Only lowercase letters (a-z) and numbers are allowed.' ) . '</p>';
  			?>
  			</td>
  		</tr>
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/network/sites.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/network/sites.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/network/sites.php	2012-10-29 12:35:31.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/network/sites.php	2012-12-17 16:18:42.000000000 -0600
***************
*** 16,28 ****
  if ( ! current_user_can( 'manage_sites' ) )
  	wp_die( __( 'You do not have permission to access this page.' ) );
  
! $wp_list_table = _get_list_table('WP_MS_Sites_List_Table');
  $pagenum = $wp_list_table->get_pagenum();
  
  $title = __( 'Sites' );
  $parent_file = 'sites.php';
  
! add_screen_option( 'per_page', array('label' => _x( 'Sites', 'sites per page (screen options)' )) );
  
  get_current_screen()->add_help_tab( array(
  	'id'      => 'overview',
--- 16,28 ----
  if ( ! current_user_can( 'manage_sites' ) )
  	wp_die( __( 'You do not have permission to access this page.' ) );
  
! $wp_list_table = _get_list_table( 'WP_MS_Sites_List_Table' );
  $pagenum = $wp_list_table->get_pagenum();
  
  $title = __( 'Sites' );
  $parent_file = 'sites.php';
  
! add_screen_option( 'per_page', array( 'label' => _x( 'Sites', 'sites per page (screen options)' ) ) );
  
  get_current_screen()->add_help_tab( array(
  	'id'      => 'overview',
***************
*** 51,85 ****
  if ( isset( $_GET['action'] ) ) {
  	do_action( 'wpmuadminedit' , '' );
  
  	switch ( $_GET['action'] ) {
- 		case 'updateblog':
- 			// No longer used.
- 		break;
  
  		case 'deleteblog':
! 			check_admin_referer('deleteblog');
! 			if ( ! ( current_user_can( 'manage_sites' ) && current_user_can( 'delete_sites' ) ) )
  				wp_die( __( 'You do not have permission to access this page.' ) );
  
  			if ( $id != '0' && $id != $current_site->blog_id && current_user_can( 'delete_site', $id ) ) {
  				wpmu_delete_blog( $id, true );
! 				wp_safe_redirect( add_query_arg( array( 'updated' => 'true', 'action' => 'delete' ), wp_get_referer() ) );
! 			} else {
! 				wp_safe_redirect( add_query_arg( array( 'updated' => 'true', 'action' => 'not_deleted' ), wp_get_referer() ) );
  			}
- 
- 			exit();
  		break;
  
  		case 'allblogs':
  			if ( ( isset( $_POST['action'] ) || isset( $_POST['action2'] ) ) && isset( $_POST['allblogs'] ) ) {
- 				check_admin_referer( 'bulk-sites' );
- 
- 				if ( ! current_user_can( 'manage_sites' ) )
- 					wp_die( __( 'You do not have permission to access this page.' ) );
- 
  				$doaction = $_POST['action'] != -1 ? $_POST['action'] : $_POST['action2'];
- 				$blogfunction = '';
  
  				foreach ( (array) $_POST['allblogs'] as $key => $val ) {
  					if ( $val != '0' && $val != $current_site->blog_id ) {
--- 51,120 ----
  if ( isset( $_GET['action'] ) ) {
  	do_action( 'wpmuadminedit' , '' );
  
+ 	if ( 'confirm' === $_GET['action'] ) {
+ 		check_admin_referer( 'confirm' );
+ 
+ 		if ( ! headers_sent() ) {
+ 			nocache_headers();
+ 			header( 'Content-Type: text/html; charset=utf-8' );
+ 		}
+ 		if ( $current_site->blog_id == $id )
+ 			wp_die( __( 'You are not allowed to change the current site.' ) );
+ 		?>
+ 		<!DOCTYPE html>
+ 		<html xmlns="http://www.w3.org/1999/xhtml" <?php language_attributes(); ?>>
+ 			<head>
+ 				<title><?php _e( 'WordPress &rsaquo; Confirm your action' ); ?></title>
+ 
+ 				<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
+ 				<?php
+ 				wp_admin_css( 'install', true );
+ 				wp_admin_css( 'ie', true );
+ 				?>
+ 			</head>
+ 			<body class="wp-core-ui">
+ 				<h1 id="logo"><a href="<?php esc_attr_e( 'http://wordpress.org/' ); ?>"><?php _e( 'WordPress' ); ?></a></h1>
+ 				<form action="sites.php?action=<?php echo esc_attr( $_GET['action2'] ) ?>" method="post">
+ 					<input type="hidden" name="action" value="<?php echo esc_attr( $_GET['action2'] ) ?>" />
+ 					<input type="hidden" name="id" value="<?php echo esc_attr( $id ); ?>" />
+ 					<input type="hidden" name="_wp_http_referer" value="<?php echo esc_attr( wp_get_referer() ); ?>" />
+ 					<?php wp_nonce_field( $_GET['action2'], '_wpnonce', false ); ?>
+ 					<p><?php echo esc_html( stripslashes( $_GET['msg'] ) ); ?></p>
+ 					<?php submit_button( __('Confirm'), 'button' ); ?>
+ 				</form>
+ 			</body>
+ 		</html>
+ 		<?php
+ 		exit();
+ 	}
+ 
+ 	$updated_action = '';
+ 
+ 	$manage_actions = array( 'deleteblog', 'allblogs', 'archiveblog', 'unarchiveblog', 'activateblog', 'deactivateblog', 'unspamblog', 'spamblog', 'unmatureblog', 'matureblog' );
+ 	if ( in_array( $_GET['action'], $manage_actions ) ) {
+ 		$action = $_GET['action'];
+ 		if ( 'allblogs' === $action )
+ 			$action = 'bulk-sites';
+ 
+ 		check_admin_referer( $action );
+ 	}
+ 
  	switch ( $_GET['action'] ) {
  
  		case 'deleteblog':
! 			if ( ! current_user_can( 'delete_sites' ) )
  				wp_die( __( 'You do not have permission to access this page.' ) );
  
+ 			$updated_action = 'not_deleted';
  			if ( $id != '0' && $id != $current_site->blog_id && current_user_can( 'delete_site', $id ) ) {
  				wpmu_delete_blog( $id, true );
! 				$updated_action = 'delete';
  			}
  		break;
  
  		case 'allblogs':
  			if ( ( isset( $_POST['action'] ) || isset( $_POST['action2'] ) ) && isset( $_POST['allblogs'] ) ) {
  				$doaction = $_POST['action'] != -1 ? $_POST['action'] : $_POST['action2'];
  
  				foreach ( (array) $_POST['allblogs'] as $key => $val ) {
  					if ( $val != '0' && $val != $current_site->blog_id ) {
***************
*** 87,244 ****
  							case 'delete':
  								if ( ! current_user_can( 'delete_site', $val ) )
  									wp_die( __( 'You are not allowed to delete the site.' ) );
! 								$blogfunction = 'all_delete';
  								wpmu_delete_blog( $val, true );
  							break;
  
  							case 'spam':
- 								$blogfunction = 'all_spam';
- 								update_blog_status( $val, 'spam', '1' );
- 								set_time_limit( 60 );
- 							break;
- 
  							case 'notspam':
! 								$blogfunction = 'all_notspam';
! 								update_blog_status( $val, 'spam', '0' );
! 								set_time_limit( 60 );
  							break;
  						}
  					} else {
  						wp_die( __( 'You are not allowed to change the current site.' ) );
  					}
  				}
- 
- 				wp_safe_redirect( add_query_arg( array( 'updated' => 'true', 'action' => $blogfunction ), wp_get_referer() ) );
  			} else {
  				wp_redirect( network_admin_url( 'sites.php' ) );
  			}
- 			exit();
  		break;
  
  		case 'archiveblog':
- 			check_admin_referer( 'archiveblog' );
- 			if ( ! current_user_can( 'manage_sites' ) )
- 				wp_die( __( 'You do not have permission to access this page.' ) );
- 
- 			update_blog_status( $id, 'archived', '1' );
- 			wp_safe_redirect( add_query_arg( array( 'updated' => 'true', 'action' => 'archive' ), wp_get_referer() ) );
- 			exit();
- 		break;
- 
  		case 'unarchiveblog':
! 			check_admin_referer( 'unarchiveblog' );
! 			if ( ! current_user_can( 'manage_sites' ) )
! 				wp_die( __( 'You do not have permission to access this page.' ) );
! 
! 			update_blog_status( $id, 'archived', '0' );
! 			wp_safe_redirect( add_query_arg( array( 'updated' => 'true', 'action' => 'unarchive' ), wp_get_referer() ) );
! 			exit();
  		break;
  
  		case 'activateblog':
- 			check_admin_referer( 'activateblog' );
- 			if ( ! current_user_can( 'manage_sites' ) )
- 				wp_die( __( 'You do not have permission to access this page.' ) );
- 
  			update_blog_status( $id, 'deleted', '0' );
  			do_action( 'activate_blog', $id );
- 			wp_safe_redirect( add_query_arg( array( 'updated' => 'true', 'action' => 'activate' ), wp_get_referer() ) );
- 			exit();
  		break;
  
  		case 'deactivateblog':
- 			check_admin_referer( 'deactivateblog' );
- 			if ( ! current_user_can( 'manage_sites' ) )
- 				wp_die( __( 'You do not have permission to access this page.' ) );
- 
  			do_action( 'deactivate_blog', $id );
  			update_blog_status( $id, 'deleted', '1' );
- 			wp_safe_redirect( add_query_arg( array( 'updated' => 'true', 'action' => 'deactivate' ), wp_get_referer() ) );
- 			exit();
  		break;
  
  		case 'unspamblog':
- 			check_admin_referer( 'unspamblog' );
- 			if ( ! current_user_can( 'manage_sites' ) )
- 				wp_die( __( 'You do not have permission to access this page.' ) );
- 
- 			update_blog_status( $id, 'spam', '0' );
- 			wp_safe_redirect( add_query_arg( array( 'updated' => 'true', 'action' => 'unspam' ), wp_get_referer() ) );
- 			exit();
- 		break;
- 
  		case 'spamblog':
! 			check_admin_referer( 'spamblog' );
! 			if ( ! current_user_can( 'manage_sites' ) )
! 				wp_die( __( 'You do not have permission to access this page.' ) );
! 
! 			update_blog_status( $id, 'spam', '1' );
! 			wp_safe_redirect( add_query_arg( array( 'updated' => 'true', 'action' => 'spam' ), wp_get_referer() ) );
! 			exit();
  		break;
  
  		case 'unmatureblog':
- 			check_admin_referer( 'unmatureblog' );
- 			if ( ! current_user_can( 'manage_sites' ) )
- 				wp_die( __( 'You do not have permission to access this page.' ) );
- 
- 			update_blog_status( $id, 'mature', '0' );
- 			wp_safe_redirect( add_query_arg( array( 'updated' => 'true', 'action' => 'unmature' ), wp_get_referer() ) );
- 			exit();
- 		break;
- 
  		case 'matureblog':
! 			check_admin_referer( 'matureblog' );
! 			if ( ! current_user_can( 'manage_sites' ) )
! 				wp_die( __( 'You do not have permission to access this page.' ) );
! 
! 			update_blog_status( $id, 'mature', '1' );
! 			wp_safe_redirect( add_query_arg( array( 'updated' => 'true', 'action' => 'mature' ), wp_get_referer() ) );
! 			exit();
  		break;
  
! 		// Common
! 		case 'confirm':
! 			check_admin_referer( 'confirm' );
! 			if ( !headers_sent() ) {
! 				nocache_headers();
! 				header( 'Content-Type: text/html; charset=utf-8' );
! 			}
! 			if ( $current_site->blog_id == $id )
! 				wp_die( __( 'You are not allowed to change the current site.' ) );
! 			?>
! 			<!DOCTYPE html>
! 			<html xmlns="http://www.w3.org/1999/xhtml" <?php language_attributes(); ?>>
! 				<head>
! 					<title><?php _e( 'WordPress &rsaquo; Confirm your action' ); ?></title>
! 
! 					<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
! 					<?php
! 					wp_admin_css( 'install', true );
! 					wp_admin_css( 'ie', true );
! 					?>
! 				</head>
! 				<body>
! 					<h1 id="logo"><img alt="WordPress" src="<?php echo esc_attr( admin_url( 'images/wordpress-logo.png?ver=20120216' ) ); ?>" /></h1>
! 					<form action="sites.php?action=<?php echo esc_attr( $_GET['action2'] ) ?>" method="post">
! 						<input type="hidden" name="action" value="<?php echo esc_attr( $_GET['action2'] ) ?>" />
! 						<input type="hidden" name="id" value="<?php echo esc_attr( $id ); ?>" />
! 						<input type="hidden" name="_wp_http_referer" value="<?php echo esc_attr( wp_get_referer() ); ?>" />
! 						<?php wp_nonce_field( $_GET['action2'], '_wpnonce', false ); ?>
! 						<p><?php echo esc_html( stripslashes( $_GET['msg'] ) ); ?></p>
! 						<?php submit_button( __('Confirm'), 'button' ); ?>
! 					</form>
! 				</body>
! 			</html>
! 			<?php
! 			exit();
! 		break;
  	}
  }
  
  $msg = '';
! if ( isset( $_REQUEST['updated'] ) && $_REQUEST['updated'] == 'true' && ! empty( $_REQUEST['action'] ) ) {
! 	switch ( $_REQUEST['action'] ) {
  		case 'all_notspam':
  			$msg = __( 'Sites removed from spam.' );
  		break;
--- 122,186 ----
  							case 'delete':
  								if ( ! current_user_can( 'delete_site', $val ) )
  									wp_die( __( 'You are not allowed to delete the site.' ) );
! 
! 								$updated_action = 'all_delete';
  								wpmu_delete_blog( $val, true );
  							break;
  
  							case 'spam':
  							case 'notspam':
! 								$updated_action = ( 'spam' === $doaction ) ? 'all_spam' : 'all_notspam';
! 								update_blog_status( $val, 'spam', ( 'spam' === $doaction ) ? '1' : '0' );
  							break;
  						}
  					} else {
  						wp_die( __( 'You are not allowed to change the current site.' ) );
  					}
  				}
  			} else {
  				wp_redirect( network_admin_url( 'sites.php' ) );
+ 				exit();
  			}
  		break;
  
  		case 'archiveblog':
  		case 'unarchiveblog':
! 			update_blog_status( $id, 'archived', ( 'archiveblog' === $_GET['action'] ) ? '1' : '0' );
  		break;
  
  		case 'activateblog':
  			update_blog_status( $id, 'deleted', '0' );
  			do_action( 'activate_blog', $id );
  		break;
  
  		case 'deactivateblog':
  			do_action( 'deactivate_blog', $id );
  			update_blog_status( $id, 'deleted', '1' );
  		break;
  
  		case 'unspamblog':
  		case 'spamblog':
! 			update_blog_status( $id, 'spam', ( 'spamblog' === $_GET['action'] ) ? '1' : '0' );
  		break;
  
  		case 'unmatureblog':
  		case 'matureblog':
! 			update_blog_status( $id, 'mature', ( 'matureblog' === $_GET['action'] ) ? '1' : '0' );
  		break;
+ 	}
  
! 	if ( empty( $updated_action ) && in_array( $_GET['action'], $manage_actions ) )
! 		$updated_action = $_GET['action'];
! 
! 	if ( ! empty( $updated_action ) ) {
! 		wp_safe_redirect( add_query_arg( array( 'updated' => $updated_action ), wp_get_referer() ) );
! 		exit();
  	}
  }
  
  $msg = '';
! if ( isset( $_GET['updated'] ) ) {
! 	switch ( $_GET['updated'] ) {
  		case 'all_notspam':
  			$msg = __( 'Sites removed from spam.' );
  		break;
***************
*** 254,282 ****
  		case 'not_deleted':
  			$msg = __( 'You do not have permission to delete that site.' );
  		break;
! 		case 'archive':
  			$msg = __( 'Site archived.' );
  		break;
! 		case 'unarchive':
  			$msg = __( 'Site unarchived.' );
  		break;
! 		case 'activate':
  			$msg = __( 'Site activated.' );
  		break;
! 		case 'deactivate':
  			$msg = __( 'Site deactivated.' );
  		break;
! 		case 'unspam':
  			$msg = __( 'Site removed from spam.' );
  		break;
! 		case 'spam':
  			$msg = __( 'Site marked as spam.' );
  		break;
  		default:
! 			$msg = apply_filters( 'network_sites_updated_message_' . $_REQUEST['action'] , __( 'Settings saved.' ) );
  		break;
  	}
! 	if ( $msg )
  		$msg = '<div class="updated" id="message"><p>' . $msg . '</p></div>';
  }
  
--- 196,225 ----
  		case 'not_deleted':
  			$msg = __( 'You do not have permission to delete that site.' );
  		break;
! 		case 'archiveblog':
  			$msg = __( 'Site archived.' );
  		break;
! 		case 'unarchiveblog':
  			$msg = __( 'Site unarchived.' );
  		break;
! 		case 'activateblog':
  			$msg = __( 'Site activated.' );
  		break;
! 		case 'deactivateblog':
  			$msg = __( 'Site deactivated.' );
  		break;
! 		case 'unspamblog':
  			$msg = __( 'Site removed from spam.' );
  		break;
! 		case 'spamblog':
  			$msg = __( 'Site marked as spam.' );
  		break;
  		default:
! 			$msg = apply_filters( 'network_sites_updated_message_' . $_GET['updated'], __( 'Settings saved.' ) );
  		break;
  	}
! 
! 	if ( ! empty( $msg ) )
  		$msg = '<div class="updated" id="message"><p>' . $msg . '</p></div>';
  }
  
***************
*** 286,296 ****
  ?>
  
  <div class="wrap">
! <?php screen_icon('ms-admin'); ?>
! <h2><?php _e('Sites') ?>
! <?php echo $msg; ?>
  <?php if ( current_user_can( 'create_sites') ) : ?>
!         <a href="<?php echo network_admin_url('site-new.php'); ?>" class="add-new-h2"><?php echo esc_html_x( 'Add New', 'site' ); ?></a>
  <?php endif; ?>
  
  <?php if ( isset( $_REQUEST['s'] ) && $_REQUEST['s'] ) {
--- 229,239 ----
  ?>
  
  <div class="wrap">
! <?php screen_icon( 'ms-admin' ); ?>
! <h2><?php _e( 'Sites' ) ?>
! 
  <?php if ( current_user_can( 'create_sites') ) : ?>
! 	<a href="<?php echo network_admin_url('site-new.php'); ?>" class="add-new-h2"><?php echo esc_html_x( 'Add New', 'site' ); ?></a>
  <?php endif; ?>
  
  <?php if ( isset( $_REQUEST['s'] ) && $_REQUEST['s'] ) {
***************
*** 298,303 ****
--- 241,248 ----
  } ?>
  </h2>
  
+ <?php echo $msg; ?>
+ 
  <form action="" method="get" id="ms-search">
  <?php $wp_list_table->search_box( __( 'Search Sites' ), 'site' ); ?>
  <input type="hidden" name="action" value="blogs" />
diff -crBPN --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=advanced-cache.php --exclude=wp-cache-config.php --exclude=wordpress.sql --exclude=wp-config.php --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.5.pl /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/network/site-themes.php /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/network/site-themes.php
*** /home/packages/code/qi/SOURCES/wordpress-3.4.2/wp-admin/network/site-themes.php	2012-10-29 12:35:31.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.5/wp-admin/network/site-themes.php	2012-12-17 16:18:42.000000000 -0600
***************
*** 13,23 ****
  if ( ! is_multisite() )
  	wp_die( __( 'Multisite support is not enabled.' ) );
  
- $menu_perms = get_site_option( 'menu_items', array() );
- 
- if ( empty( $menu_perms['themes'] ) && ! is_super_admin() )
- 	wp_die( __( 'Cheatin&#8217; uh?' ) );
- 
  if ( ! current_user_can( 'manage_sites' ) )
  	wp_die( __( 'You do not have sufficient permissions to manage themes for this site.' ) );
  
--- 13,18 ----
***************
*** 177,183 ****
  <?php $wp_list_table->views(); ?>
  
  <form method="post" action="site-themes.php?action=update-site">
- 	<?php wp_nonce_field( 'edit-site' ); ?>
  	<input type="hidden" name="id" value="<?php echo esc_attr( $id ) ?>" />
  
  <?php $wp_list_table->display(); ?>
--- 172,177 ----
